package javax.safetycritical;

import java.lang.System;

import java.io.File;
import java.io.FileInputStream;
import java.io.FileNotFoundException;

import javax.realtime.ImmortalMemory;



public final class S3Launcher {

	public static class LauncherThread extends Thread {

		static String _className;
		static String _propFileName;

		@Override
		public void run() {
			ImmortalMemory.instance().executeInArea(new Runnable() {
				public void run() {
					try {
						Class mainClass = Class.forName(_className);
						if (Safelet.class.isAssignableFrom(mainClass)) {
							S3Terminal.setInputStream(new FileInputStream(
									new File(_propFileName)));
							Safelet safelet = (Safelet) (mainClass
									.newInstance());

							MissionManager.setLevel(safelet.getLevel());
							safelet.setup();
							MissionSequencer sequencer = safelet.getSequencer();
							sequencer.start();
							try {
								// sleep forever waiting for mission terminates
								Thread.sleep(Long.MAX_VALUE);
							} catch (InterruptedException e) {
								safelet.teardown();
							}
							System.exit(1);
						} else
							writeln("Main class >>" + mainClass
									+ " must be subclass of " + Safelet.class);
					} catch (ClassNotFoundException e) {
						writeln("Class >>" + _className + "<< not found: " + e);
						java.lang.System.exit(1);

					} catch (InstantiationException e) {
						writeln("Class >>" + _className
								+ "<< could not be instantiated: " + e);
						java.lang.System.exit(1);

					} catch (IllegalAccessException e) {
						writeln("Class >>" + _className
								+ "<< could not be instantiated: " + e);
						java.lang.System.exit(1);

					} catch (FileNotFoundException e1) {
						writeln(e1.getMessage());
						java.lang.System.exit(1);
					}
				}
			});
		}
	};

	public static void main(final String[] args) {
		String usageInfo = "Usage: <jvm> <safelet class> <config file> \n";

		if (args.length == 0) {
			writeln(usageInfo);
			System.exit(1);
		}

		try {
			LauncherThread thread = (LauncherThread) ImmortalMemory.instance()
					.newInstance(LauncherThread.class);
			LauncherThread._className = args[0];
			LauncherThread._propFileName = args[1];
			thread.start();
		} catch (InstantiationException e) {
			e.printStackTrace();
		} catch (IllegalAccessException e) {
			e.printStackTrace();
		}
	}

	private static void writeln(String msg) {
		Terminal.getTerminal().writeln(msg);
	}
}
