package javax.safetycritical;

import java.io.IOException;
import java.io.InputStream;

import javax.safetycritical.annotate.SCJAllowed;

public class S3Terminal {

	private static S3Terminal _single = new S3Terminal();

	private static InputStream _in;

	private S3Terminal() {
	}

	/**
	 * Get the single output device.
	 * 
	 * @return
	 */
	@SCJAllowed
	public static S3Terminal getTerminal() {
		return _single;
	}

	static void setInputStream(InputStream in) {
		_in = in;
	}

	public CharSequence readAll() {
		if (_in == null)
			return null;
		byte[] bytebuf = null;
		char[] charbuf = null;
		try {
			bytebuf = new byte[_in.available()];
			charbuf = new char[_in.available()];
			_in.read(bytebuf);
		} catch (IOException e) {
			e.printStackTrace();
		}
		for (int i = 0; i < bytebuf.length; i++) {
			charbuf[i] = (char) bytebuf[i];
		}
		return new StringBuffer().append(charbuf);
	}
}
